## nsis 3.02.1

=== debian/changelog ===
nsis (3.02.1-1) experimental; urgency=low

  * New 3.02.1 upstream release
  * Bump debhelper compat to 10
  * Bump Standards-Version to 4.0.1 without changes needed

 -- Didier Raboud <odyx@debian.org>  Thu, 31 Aug 2017 20:44:15 +0200

nsis (3.01-1) experimental; urgency=medium

  * New 3.01 upstream release
  * Drop all patches, all included upstream

 -- Didier Raboud <odyx@debian.org>  Fri, 16 Dec 2016 13:15:34 +0100

nsis (3.0-5) experimental; urgency=medium

  * Backport upstream workaround for '#1156 zlibCompressionTest loops
    endlessly'

 -- Didier Raboud <odyx@debian.org>  Sun, 11 Dec 2016 09:40:39 +0100

nsis (3.0-4) experimental; urgency=medium

  * Only build in parallel in builds without arch-all packages, to circumvent
    arch:all FTBFS

 -- Didier Raboud <odyx@debian.org>  Fri, 09 Dec 2016 16:15:19 +0100

nsis (3.0-3) experimental; urgency=medium

  [ Thomas Gaugler ]
  * makensis man page: OUTPUTCHARSET is not applicable for POSIX systems
  * Added Patch: WinWStrDupFromChar writes beyond allocated memory
  * Updated plugin api library description (new: amd64 & unicode)
  * Added Patch: Make WinWStrDupFromWC endian agnostic

  [ Didier Raboud ]
  * Add BUILD_ARCH endianness test at the start of the build-indep target

 -- Didier Raboud <odyx@debian.org>  Wed, 05 Oct 2016 08:40:53 +0200

nsis (3.0-2) experimental; urgency=low

  * Build makensis in build-indep to fix indep-only FTBFS

 -- Didier Raboud <odyx@debian.org>  Fri, 12 Aug 2016 17:24:06 +0200

nsis (3.0-1) experimental; urgency=low

  * New 3.0 upstream release

  [ Thomas Gaugler ]
  * Remove all patches for new upstream release
  * Build installer for win32 and win64
  * Use secure URL for Vcs-Browser field
  * Changed debian/copyright into a standard, machine-readable format
  * Build all plugins for win64
  * Removed unused nsis.lintian-overrides file
  * Updated makensis man page
  * Remove duplicate AUTHOR section in LibraryLocal man page
  * Remove duplicate AUTHOR section in GenPat man page
  * Simplify extraction of Version from changelog
  * Removed obsolete and completed tasks from TODO file

  [ Didier Raboud ]
  * Add missing dpkg-dev versioned B-D for dpkg-parsechangelog's --show-field
  * Re-add patch to statically link libstdc++ for plugins

 -- Didier Raboud <odyx@debian.org>  Fri, 12 Aug 2016 14:36:48 +0200
