=== debian/control ===
Source: nsis
Maintainer: Thomas Gaugler <thomas@dadie.net>
Uploaders: Didier Raboud <odyx@debian.org>
Section: devel
Priority: optional
Build-Depends: debhelper (>= 11),
               docbook-xsl-ns,
               docbook5-xml,
               dpkg-dev (>= 1.17.0),
               html2text,
               libcppunit-dev,
               mingw-w64,
               scons,
               xsltproc,
               zlib1g-dev
Standards-Version: 4.1.3
Vcs-Browser: https://salsa.debian.org/debian/nsis
Vcs-Git: https://salsa.debian.org/debian/nsis.git
Homepage: http://nsis.sourceforge.net/

Package: nsis
Architecture: any
Depends: nsis-common (>= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: mingw-w64,
          nsis-doc (>= ${source:Version}),
          nsis-pluginapi (>= ${source:Version}),
          wine [amd64 i386 kfreebsd-amd64 kfreebsd-i386 powerpc]
Description: Nullsoft Scriptable Install System (modified for Debian)
 NSIS is a tool for creating quick and user friendly installers for
 Microsoft Windows (Win32) operating systems.
 .
 NSIS creates installers that are capable of installing, uninstalling,
 setting system settings, extracting files, etc. Because it's based on
 script files, you can fully control every part of your installers. The
 script language supports variables, functions, string manipulation,
 just like a normal programming language - but designed for the creation
 of installers. Even with all these features, NSIS is still the smallest
 installer system available. With the default options, it has an overhead
 of only 34 KB.

Package: nsis-common
Architecture: all
Depends: ${misc:Depends}
Description: Nullsoft Scriptable Install System stubs and plugins
 NSIS is a tool for creating quick and user friendly installers for
 Microsoft Windows (Win32) operating systems.
 .
 This package contains the stubs and plugins of NSIS.

Package: nsis-pluginapi
Architecture: all
Depends: ${misc:Depends}
Recommends: mingw-w64
Enhances: nsis (>= ${source:Version})
Description: Nullsoft Scriptable Install System plugin API
 NSIS is a tool for creating quick and user friendly installers for
 Microsoft Windows (Win32) operating systems.
 .
 This package contains the header and library files for developing
 NSIS plugins.

Package: nsis-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Nullsoft Scriptable Install System documentation
 NSIS is a tool for creating quick and user friendly installers for
 Microsoft Windows (Win32) operating systems.
 .
 This package contains examples and the documentation in HTML format.
