## nsis 3.04

=== SConstruct ===
--- 
+++ 
@@ -30,7 +30,6 @@
 ]
 
 utils = [
-	'Library/LibraryLocal',
 	'Library/RegTool',
 	'MakeLangId',
 	'Makensisw',
@@ -143,12 +142,11 @@
 else:
 	dirs = install_dirs['relocatable']
 
-if 'msvc' in defenv['TOOLS'] or 'mstoolkit' in defenv['TOOLS']:
+if defenv['PLATFORM'] == 'win32':
 	ignore_tests = 'none'
 else:
 	ignore_tests = ','.join(Split("""
-Examples/makensis.nsi
-Examples/gfx.nsi"""))
+Examples/makensis.nsi"""))
 
 # version
 opts.Add(('VERSION', 'Version of NSIS', cvs_version))
@@ -161,7 +159,7 @@
 opts.Add(('PREFIX', 'Installation prefix', dirs['prefix']))
 opts.Add(ListVariable('SKIPSTUBS', 'A list of stubs that will not be built', 'none', stubs))
 opts.Add(ListVariable('SKIPPLUGINS', 'A list of plug-ins that will not be built', 'none', plugin_libs + plugins))
-opts.Add(ListVariable('SKIPUTILS', 'A list of utilities that will not be built', 'none', utils))
+opts.Add(ListVariable('SKIPUTILS', 'A list of utilities that will not be built', 'NSIS Menu', utils))
 opts.Add(ListVariable('SKIPMISC', 'A list of plug-ins that will not be built', 'none', misc))
 opts.Add(ListVariable('SKIPDOC', 'A list of doc files that will not be built/installed', 'none', doc))
 opts.Add(('SKIPTESTS', 'A comma-separated list of test files that will not be ran', 'none'))
@@ -171,7 +169,7 @@
 opts.Add(('TOOLSET', 'A comma-separated list of specific tools used for building instead of the default', None))
 opts.Add(BoolVariable('MSTOOLKIT', 'Use Microsoft Visual C++ Toolkit', 'no'))
 opts.Add(EnumVariable('MSVS_VERSION', 'MS Visual C++ version', os.environ.get('MSVS_VERSION'), allowed_values=('6.0', '7.0', '7.1', '8.0', '8.0Exp', '9.0', '9.0Exp', '10.0', '10.0Exp')))
-opts.Add(EnumVariable('TARGET_ARCH', 'Target processor architecture', 'x86', allowed_values=('x86', 'amd64')))
+opts.Add(EnumVariable('TARGET_ARCH', 'Target processor architecture', 'x86', allowed_values=('x86', 'amd64', 'arm64')))
 opts.Add(ListVariable('DOCTYPES', 'A list of document types that will be built', default_doctype, doctypes))
 opts.Add(('CC', 'Override C compiler', None))
 opts.Add(('CXX', 'Override C++ compiler', None))
@@ -256,14 +254,28 @@
 f.write('#include "%s"\n' % File('#/Source/tchar.h').abspath)
 
 if (not defenv.has_key('VER_PACKED')) and defenv.has_key('VER_MAJOR') and defenv.has_key('VER_MINOR'):
-	packed_r = packed_b = 0
-	if defenv.has_key('VER_REVISION'):
-		packed_r = int(defenv['VER_REVISION'])
-	if defenv.has_key('VER_BUILD'):
-		packed_b = int(defenv['VER_BUILD'])
-	defenv['VER_PACKED'] = '0x%0.2i%0.3i%0.2i%0.1i' % (int(defenv['VER_MAJOR']),int(defenv['VER_MINOR']),packed_r,packed_b)
-if defenv.has_key('VER_PACKED'):
-	f.write('#define NSIS_PACKEDVERSION _T("%s")\n' % defenv['VER_PACKED'])
+	packed_r = int(defenv.get('VER_REVISION','0'))
+	packed_b = int(defenv.get('VER_BUILD','0'))
+	defenv['VER_PACKED'] = '0x%0.2i%0.3i%0.2i%0.1i' % (int(defenv['VER_MAJOR']), int(defenv['VER_MINOR']), packed_r, packed_b)
+if not defenv.has_key('VER_PACKED'):
+	import re
+	found = None
+	for v in re.compile(r'^\\H\{[v]?(\S+)\}', re.M).finditer(File('#/Docs/src/history.but').get_contents()): # Try to parse the Halibut history file
+		if v and not found:
+			v = v.group(1).split('.')
+			if len(v) >= 2:
+				mi = int(re.search(r'\d+', v[1]).group())
+				if mi < 1: mi = 1 # Make sure we can subtract 1 from the minor number so trunk stays below the next release
+				defenv['VER_PACKED'] = '0x%0.2i%0.3i%0.2i%0.1i' % (int(re.search(r'\d+', v[0]).group()), mi - 1, 66, 6)
+				if int(defenv['VER_PACKED'], 0) >= int('0x03000000', 0):
+					found = v
+	if not found:
+		defenv['VER_PACKED'] = '0x%0.2i%0.3i%0.2i%0.1i' % (3, 3, 42, 0) # Default to a version number we never used
+	print('WARNING: VER_PACKED not set, defaulting to %s!' % defenv['VER_PACKED'])
+if int(defenv['VER_PACKED'], 0) < int('0x03000000', 0) or int(defenv['VER_PACKED'], 0) >= int('0x04000000', 0):
+	print('ERROR: Invalid VER_PACKED value!')
+	Exit(1)
+f.write('#define NSIS_PACKEDVERSION _T("%s")\n' % defenv['VER_PACKED'])
 
 if defenv.has_key('VER_MAJOR') and defenv.get('VERSION','') == '':
 	defenv['VERSION'] = defenv['VER_MAJOR']
@@ -271,12 +283,6 @@
 		defenv['VERSION'] += '.' + defenv['VER_MINOR']
 	if defenv.has_key('VER_REVISION'):
 		defenv['VERSION'] += '.' + defenv['VER_REVISION']
-
-if (not defenv.has_key('TARGET_ARCH')) or defenv['TARGET_ARCH'] == 'x86':
-	vermaj = 0
-	if defenv.has_key('VER_MAJOR'):
-		vermaj = int(defenv['VER_MAJOR'])
-
 f.write('#define NSIS_VERSION _T("v%s")\n' % defenv['VERSION'])
 
 f.close()
@@ -284,6 +290,19 @@
 ######################################################################
 #######  Common Functions                                          ###
 ######################################################################
+
+def GetArcCPU(env):
+	if (not env.has_key('TARGET_ARCH')) or env['TARGET_ARCH'] == 'x86':
+		return 'x86'
+	return env['TARGET_ARCH']
+
+def GetArcSuffix(env, unicode = None):
+	if unicode is None:
+		unicode = 'UNICODE' in env['CPPDEFINES']
+	suff = '-unicode'
+	if not unicode:
+		suff = '-ansi'
+	return GetArcCPU(env) + suff
 
 def SafeFile(f):
 	from types import StringType
@@ -298,36 +317,3 @@
 
 def AddEnvStandardFlags(env, defines=None, flags=None, libs=None, entry=None, nodeflib=None):
 	if defines:
-		env.Append(CPPDEFINES = defines)
-	if flags:
-		env.Append(CCFLAGS = flags)
-	if libs:
-		env.Append(LIBS = libs)
-
-	if entry:
-		unicodestr = "None"
-		if 'UNICODE' in env['CPPDEFINES']:
-			unicodestr = "True"
-		env.Append(LINKFLAGS = ['${ENTRY_FLAG("%s",%s)}' % (entry,unicodestr)])
-
-	if nodeflib:
-		env.Append(LINKFLAGS = ['$NODEFLIBS_FLAG']) # no default libraries
-
-def AppendRES(env, source, res, resources):
-	if res:
-		target = MakeFileList(res)[0].name.replace('.rc', '-rc')
-		target_res = env.RES(target, res)
-		if resources:
-			env.Depends(target_res, resources)
-		source.append(target_res)
-
-def CleanMap(env, target, target_name):
-	env.Clean(target, File(target_name + '.map'))
-
-
-######################################################################
-#######  Functions                                                 ###
-######################################################################
-
-defenv['ZIPDISTDIR'] = defenv.Dir('#nsis-$VERSION')
-defenv['INSTDISTDIR'] = defenv.Dir('#.instdist')
