=== debian/changelog ===
nsis (3.04-1) unstable; urgency=medium

  * New 3.04 upstream release

  [ Thomas Gaugler ]
  * Provide decomposed version to indirectly set packed version
  * Remove LibraryLocal from build following upstream

  [ Ondřej Nový ]
  * d/changelog: Remove trailing whitespaces
  * d/rules: Remove trailing whitespaces
  * d/watch: Use https protocol

 -- Thomas Gaugler <thomas@dadie.net>  Mon, 07 Jan 2019 08:40:25 +0100

nsis (3.03-2) unstable; urgency=low

  * Migrate NSIS 3 to unstable

  [ Thomas Gaugler ]
  * Correct and refactor SKIPUTILS parameter setting
  * Reactivate Library.nsi test case

  [ Didier Raboud ]
  * Add gbp.conf
  * Mark nsis-{common,pluginapi,doc} Multi-Arch: foreign

 -- Didier Raboud <odyx@debian.org>  Sat, 31 Mar 2018 14:53:58 +0200
