=== debian/rules ===
--- 
+++ 
@@ -18,6 +18,15 @@
 UNICODE=yes
 TESTDIR=$(CURDIR)/$(BUILDDIR)/test
 
+# Decomposition of version string
+define SPLIT
+	$(if $(2),$(call SPLIT,$(subst $(firstword $(2)), ,$(1)),$(filter-out $(firstword $(2)), $(2))), $(1))
+endef
+VERSION_DECOMPOSED=$(call SPLIT,$(VERSION),. -)
+VER_MAJOR=$(firstword $(VERSION_DECOMPOSED))
+VER_MINOR=$(word 2,$(VERSION_DECOMPOSED))
+VER_REVISION=$(word 3,$(VERSION_DECOMPOSED))
+
 # Variables for Win32/Win64 cross compiler
 XGCC_W32_X86 = i686-w64-mingw32-gcc
 XGCC_W32_X86_PATH = $(abspath $(shell $(XGCC_W32_X86) -print-file-name=libkernel32.a)/../..)
@@ -40,7 +49,8 @@
   $(shell dpkg-buildflags --get CFLAGS)" \
   APPEND_LINKFLAGS="$(shell dpkg-buildflags --get LDFLAGS)"
 
-SCONSOPTS = $(SCONSFLAGS) VERSION=$(VERSION) \
+SCONSOPTS = $(SCONSFLAGS) VERSION=$(VERSION) VER_MAJOR=$(VER_MAJOR) \
+  VER_MINOR=$(VER_MINOR) VER_REVISION=$(VER_REVISION) \
   PREFIX=$(PREFIX) PREFIX_CONF=$(SYSCONF) CHMDOCS=0 \
   STRIP_CP=no \
   $(if $(findstring nostripfull,$(DEB_BUILD_OPTIONS)),STRIP_W32=no,)
@@ -73,16 +83,17 @@
 
 COMMA := ,
 
-UTILS_ALL = 'Library/LibraryLocal,Library/RegTool,MakeLangId,Makensisw,NSIS Menu,UIs,SubStart,VPatch/Source/GenPat,zip2exe'
-
-IGNORE_UTILS_NSIS   := $(subst Library/LibraryLocal$(COMMA),,$(UTILS_ALL))
-IGNORE_UTILS_NSIS   := $(subst $(COMMA)VPatch/Source/GenPat,,$(IGNORE_UTILS_NSIS))
-IGNORE_UTILS_COMMON := $(subst $(COMMA)Library/RegTool$,,$(UTILS_ALL))
+UTILS_ALL = 'Library/RegTool,MakeLangId,Makensisw,NSIS Menu,UIs,SubStart,VPatch/Source/GenPat,zip2exe'
+
+# Only build GenPat for the host system
+IGNORE_UTILS_NSIS   := $(subst $(COMMA)VPatch/Source/GenPat,,$(UTILS_ALL))
+
+# Build the win32 user interfaces (UIs) and RegTool
+IGNORE_UTILS_COMMON := $(subst Library/RegTool,,$(UTILS_ALL))
 IGNORE_UTILS_COMMON := $(subst $(COMMA)UIs,,$(IGNORE_UTILS_COMMON))
 
-IGNORE_UTILS_CLEAN  := $(IGNORE_UTILS_COMMON)
-IGNORE_UTILS_CLEAN  := $(subst Library/LibraryLocal$(COMMA),,$(IGNORE_UTILS_COMMON))
-IGNORE_UTILS_CLEAN  := $(subst $(COMMA)VPatch/Source/GenPat,,$(IGNORE_UTILS_CLEAN))
+# Clean everything except zip2exe pulling in a dependency on win32 zlib dll
+IGNORE_UTILS_CLEAN  := zip2exe
 
 SCONSOPTS_HOST   := $(SCONSHOSTFLAGS) $(SCONSOPTS) \
   SKIPUTILS=$(IGNORE_UTILS_NSIS) SKIPDOC=COPYING
@@ -100,7 +111,7 @@
 INSTALL_FLAGS_nsis-doc = $(SCONSOPTS_HOST)
 
 # Exclude test scripts which are not appropriate for POSIX platforms.
-IGNORE_TESTS = makensis.nsi|gfx.nsi|Library.nsi
+IGNORE_TESTS = makensis.nsi|gfx.nsi
 
 # Path to .nsi scripts
 SCRIPTS_PATH = $(DOCDIR)/Examples
@@ -205,17 +216,5 @@
 			|| exit 1; \
 		fi;; \
 		esac; \
-	done; 
+	done;
 	# Fail the build if libwinpthread is needed at runtime (see #722898)
-	test `find $(TESTDIR)$(DATADIR)/Plugins -iname "*.dll" -exec objdump -p {} \; | grep -E "file format|DLL Name" | grep -cim1 libwinpthread` -eq 0
-endif
-
-override_dh_auto_install-arch:
-	$(foreach p,$(shell dh_listpackages -a),$(call DO_SCONS_INSTALL,$(p)))
-
-override_dh_fixperms-arch:
-	dh_fixperms
-	find "$(CURDIR)/debian/nsis/$(SYSCONF)" \
-		-type f -perm /111 -exec chmod a-x {} \;
-
-override_dh_auto_install-indep:
